﻿Public Class Form1

  Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
    End
  End Sub

  Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
    Dim _C1Doc As New C1.C1Preview.C1PrintDocument
    Dim _C1Render As New C1.C1Preview.RenderC1Printable
    Dim _C1PrintPrevDiag As New C1.Win.C1Preview.C1PrintPreviewDialog
    'Configuramos las páginas de la vista preliminar
    _C1Doc.PageLayout.PageSettings.TopMargin = New C1.C1Preview.Unit(C1TDBG1.PrintInfo.PageSettings.Margins.Top, C1.C1Preview.UnitTypeEnum.InHs)
    _C1Doc.PageLayout.PageSettings.BottomMargin = New C1.C1Preview.Unit(C1TDBG1.PrintInfo.PageSettings.Margins.Bottom, C1.C1Preview.UnitTypeEnum.InHs)
    _C1Doc.PageLayout.PageSettings.LeftMargin = New C1.C1Preview.Unit(C1TDBG1.PrintInfo.PageSettings.Margins.Left, C1.C1Preview.UnitTypeEnum.InHs)
    _C1Doc.PageLayout.PageSettings.RightMargin = New C1.C1Preview.Unit(C1TDBG1.PrintInfo.PageSettings.Margins.Right, C1.C1Preview.UnitTypeEnum.InHs)
    _C1Doc.PageLayout.PageSettings.UsePrinterPaperSize = True
    _C1Doc.PageLayout.PageSettings.Landscape = C1TDBG1.PrintInfo.PageSettings.Landscape
    _C1Doc.PageLayout.PageSettings.PaperSourceRawKind = C1TDBG1.PrintInfo.PageSettings.PaperSource.RawKind
    _C1Doc.PageLayout.PageSettings.PaperKind = C1TDBG1.PrintInfo.PageSettings.PaperSize.Kind
    'Configuramos la cabecera del documento
    If C1TDBG1.PrintInfo.PageHeader.Trim.Length > 0 Then
      _C1Doc.PageLayout.PageHeader = New C1.C1Preview.RenderText(C1TDBG1.PrintInfo.PageHeader)
      _C1Doc.PageLayout.PageHeader.Style.BackColor = C1TDBG1.PrintInfo.PageHeaderStyle.BackColor
      _C1Doc.PageLayout.PageHeader.Style.TextColor = C1TDBG1.PrintInfo.PageHeaderStyle.ForeColor
      _C1Doc.PageLayout.PageHeader.Style.Font = C1TDBG1.PrintInfo.PageHeaderStyle.Font
      _C1Doc.PageLayout.PageHeader.Height = New C1.C1Preview.Unit(C1TDBG1.PrintInfo.PageHeaderHeight, C1.C1Preview.UnitTypeEnum.InHs)
    End If
    'Configuramos el pie del documento
    If C1TDBG1.PrintInfo.PageFooter.Trim.Length > 0 Then
      _C1Doc.PageLayout.PageFooter = New C1.C1Preview.RenderText("[""" & traducir(1163, "Página") & " "" & PageNo & "" " & traducir(157, "de") & " "" & PageCount]")
      _C1Doc.PageLayout.PageFooter.Style.BackColor = C1TDBG1.PrintInfo.PageFooterStyle.BackColor
      _C1Doc.PageLayout.PageFooter.Style.TextColor = C1TDBG1.PrintInfo.PageFooterStyle.ForeColor
      _C1Doc.PageLayout.PageFooter.Style.Font = C1TDBG1.PrintInfo.PageFooterStyle.Font
      _C1Doc.PageLayout.PageFooter.Style.TextAlignHorz = C1.C1Preview.AlignHorzEnum.Center
      _C1Doc.PageLayout.PageFooter.Height = New C1.C1Preview.Unit(C1TDBG1.PrintInfo.PageFooterHeight, C1.C1Preview.UnitTypeEnum.InHs)
    End If
    'Renderizamos la TDBGNET a un PrintDocument
    _C1Render.Object = C1TDBG1
    _C1Render.GenerateInnerRenderObjects()

    '' Rather than using the RenderC1Printable itself, we use the RenderTable created by it that represents the table:
    Dim _C1RenderTable As C1.C1Preview.RenderTable
    _C1RenderTable = _C1Render.Children(0)
    '' This will allow us to assing 'table' directly to our C1PrintDocument.Body.Children:
    _C1Render.Children.Clear()
    '' Can add table to the document now:
    _C1Doc.Body.Children.Add(_C1RenderTable)

    '' Set up table's properties:
    _C1RenderTable.Width = C1.C1Preview.Unit.Auto
    '' Use this line instead of next, to auto-size the columns rather than using the current widths:
    ''_C1RenderTable.ColumnSizingMode = C1.C1Preview.TableSizingModeEnum.Auto
    _C1RenderTable.ColumnSizingMode = C1.C1Preview.TableSizingModeEnum.Fixed
    For i As Short = 0 To _C1RenderTable.Cols.Count
      '' Uncommenting the next line and setting ColumnSizingMode to Auto above will auto-size columns:
      ''_C1RenderTable.Cols(i).Width = C1.C1Preview.Unit.Auto
    Next
    _C1RenderTable.SplitHorzBehavior = C1.C1Preview.SplitBehaviorEnum.SplitIfNeeded
    _C1RenderTable.SplitVertBehavior = C1.C1Preview.SplitBehaviorEnum.SplitIfNeeded

    '' Generate the document:
    _C1Doc.Generate()

    'Preparamos la ventana de la vista previa
    With _C1PrintPrevDiag
      .Document = _C1Doc
      .ShowInTaskbar = False
      .WindowState = FormWindowState.Maximized
      .NavigationPanelVisible = False
      .AvailablePreviewActions = C1.Win.C1Preview.C1PreviewActionFlags.FileSave
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.PageSetup
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.Print
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.GoFirst
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.GoLast
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.GoNext
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.GoPage
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.GoPrev
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.PageView
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.HandTool
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.SelectTextTool
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.ZoomFactor
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.ZoomIn
      .AvailablePreviewActions = .AvailablePreviewActions Or C1.Win.C1Preview.C1PreviewActionFlags.ZoomOut
      .Text = traducir(1245, "Vista Preliminar")
      .PrintPreviewControl.PreviewPane.ShowRulers = False
      .PrintPreviewControl.PreviewPane.ZoomFactor = 0.75
      With .PrintPreviewControl.ToolBars
        'Traducimos los tooltips de los botones de la vista previa
        .File.Save.ToolTipText = traducir(1409, "Guardar")
        .File.PageSetup.ToolTipText = traducir(1371, "Configurar")
        .File.Print.ToolTipText = traducir(4143, "Imprimir")
        .Navigation.GoFirst.ToolTipText = traducir(11224, "Primera Página")
        .Navigation.GoPrev.ToolTipText = traducir(11227, "Página Anterior")
        .Navigation.GoNext.ToolTipText = traducir(11226, "Página Siguiente")
        .Navigation.GoLast.ToolTipText = traducir(11225, "Ultima Página")
        .Navigation.LblOfPages.Text = .Navigation.LblOfPages.Text.Replace("of", traducir(157, "de"))
        .Navigation.LblPage.Text = traducir(1163, "Página")
        .Zoom.ZoomIn.ToolTipText = traducir(11221, "Ampliar")
        .Zoom.ZoomOut.ToolTipText = traducir(11222, "Reducir")
        .Zoom.DropZoomFactor.DropDownItems(12).Text = traducir(11091, "Tamaño normal")
        .Zoom.DropZoomFactor.DropDownItems(13).Text = traducir(12415, "Ancho de página")
        .Zoom.DropZoomFactor.DropDownItems(14).Text = traducir(12416, "Ancho del texto")
        .Zoom.DropZoomFactor.DropDownItems(15).Text = traducir(12417, "Toda la página")
        .Page.Single.ToolTipText = traducir(12418, "Ajustar a una página")
        .Page.Continuous.ToolTipText = traducir(12419, "Desplazamiento en una página")
        .Page.Facing.ToolTipText = traducir(12420, "Ajustar a dos páginas")
        .Page.FacingContinuous.ToolTipText = traducir(12421, "Desplazamiento en dos páginas")
        .Text.Hand.ToolTipText = traducir(9985, "Desplazamiento")
        .Text.SelectText.ToolTipText = traducir(1687, "Selección")
      End With
      'Mostramos la ventana de la vista previa
      .ShowDialog()
    End With
  End Sub

  Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    Dim dtt As New DataTable
    dtt.Columns.Add(New DataColumn("seleccionado", System.Type.GetType("System.Boolean")))
    dtt.Columns.Add(New DataColumn("descripcion"))
    dtt.Columns.Add(New DataColumn("abreviatura"))
    dtt.Columns.Add(New DataColumn("color"))
    dtt.Columns.Add(New DataColumn("colordato"))
    dtt.Columns.Add(New DataColumn("tipocolor"))
    dtt.Columns.Add(New DataColumn("padre"))
    dtt.Columns.Add(New DataColumn("retales"))
    dtt.Columns.Add(New DataColumn("tiporetales"))
    dtt.Columns.Add(New DataColumn("bicolor", System.Type.GetType("System.Boolean")))
    dtt.Columns.Add(New DataColumn("veta", System.Type.GetType("System.Boolean")))
    dtt.Columns.Add(New DataColumn("orden"))
    dtt.Rows.Add(dtt.NewRow)
    dtt.Rows(0)("seleccionado") = True
    dtt.Rows(0)("descripcion") = "COLOR1"
    dtt.Rows(0)("abreviatura") = "CLR1"
    dtt.Rows(0)("color") = 0
    dtt.Rows(0)("colordato") = 0
    dtt.Rows(0)("tipocolor") = 1
    dtt.Rows(0)("padre") = 2
    dtt.Rows(0)("retales") = 10
    dtt.Rows(0)("tiporetales") = 0
    dtt.Rows(0)("bicolor") = False
    dtt.Rows(0)("veta") = False
    dtt.Rows(0)("orden") = 1
    C1TDBG1.DataSource = dtt
  End Sub

  Private Function traducir(ByVal p1 As Short, ByVal p2 As String) As String
    Return p2
  End Function

End Class
